Page MenuHomePhabricator

Edit cards: re-think positioning of mobile contexts
Closed, ResolvedPublic

Description

Currently we position all mobile contexts at the top of the screen to avoid them being hidden by the virtual keyboard on iOS:

This has a couple of problems:

  1. There is limited space to show information, so we only show the most basic information (target for a link, title for citations).
  2. The page jumps down when the context is show, which can be frustrating if you are trying to adjust your selection.

However most inspectors are for focusable nodes, where the virtual keyboard is not shown [1]:

It may make sense to design contexts around this more common case, and use the fact that we can attach contexts to the bottom of the screen if the keyboard is not shown, such designs were proposed in T93325:

It was also proposed at that time that link inspectors would trigger this same behaviour and hide the keyboard, showing an inspector that has an "edit label" button, however I think this would be frustrating for the user as they are probably as likely (or more likely) to want to edit the link label.

Note 1:
Contexts shown with the keyboard present:

  • Link
  • LanguageAnnotation (v. rare)

Contexts shown without the keyboard:

  • References
  • Templates
  • Images
  • Galleries
  • Other extesnsion (Math, Maps, etc.)
  • Comments

Event Timeline

Esanders created this task.Sep 18 2018, 4:14 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptSep 18 2018, 4:14 PM
JTannerWMF moved this task from To Triage to Q4 on the VisualEditor board.Mar 12 2019, 3:23 PM

This would resolve T96289 as well.

Esanders added a comment.EditedApr 2 2019, 6:22 PM

Here's how this would look with our current toolbar and desktop context styling:

The big question left to answer is what to show when the cursor is initially placed in a link, as we don't want to hide the keyboard immediately.

CC @iamjessklein

iamjessklein renamed this task from Re-think positioning of mobile contexts to EPIC: Re-think positioning of mobile contexts.Apr 8 2019, 1:42 PM
iamjessklein added a project: Epic.
iamjessklein renamed this task from EPIC: Re-think positioning of mobile contexts to Re-think positioning of mobile contexts.Apr 8 2019, 1:53 PM
iamjessklein removed a project: Epic.
ppelberg renamed this task from Re-think positioning of mobile contexts to Edit cards: re-think positioning of mobile contexts.Apr 17 2019, 9:49 PM

The questions in this ticket will be resolved as a result of the prototype @iamjessklein is creating.

@Esanders are you satisfied with how the issues raised in this ticket have been represented in T220385? I ask in the context of wondering whether it's appropriate to close this ticket in an effort to collect the conversation around the context items in one place...

Change 510229 had a related patch set uploaded (by Esanders; owner: Esanders):
[VisualEditor/VisualEditor@master] WIP Move mobile context to bottom of page

https://gerrit.wikimedia.org/r/510229

Change 510230 had a related patch set uploaded (by Esanders; owner: Esanders):
[mediawiki/extensions/VisualEditor@master] WIP Move mobile context to bottom of page

https://gerrit.wikimedia.org/r/510230

ppelberg closed this task as Resolved.May 20 2019, 3:26 PM
ppelberg claimed this task.
matmarex reopened this task as Open.Jun 14 2019, 8:00 PM
matmarex removed ppelberg as the assignee of this task.
matmarex added a subscriber: matmarex.

(still has patches for review, I assume this was accidentally closed)

Change 510229 merged by jenkins-bot:
[VisualEditor/VisualEditor@master] Move mobile context to bottom of page

https://gerrit.wikimedia.org/r/510229

Change 517137 had a related patch set uploaded (by Bartosz Dziewoński; owner: Bartosz Dziewoński):
[mediawiki/extensions/VisualEditor@master] Update VE core submodule to master (44556e8fd)

https://gerrit.wikimedia.org/r/517137

Change 517137 merged by jenkins-bot:
[mediawiki/extensions/VisualEditor@master] Update VE core submodule to master (44556e8fd)

https://gerrit.wikimedia.org/r/517137

Change 510230 merged by jenkins-bot:
[mediawiki/extensions/VisualEditor@master] Move mobile context to bottom of page

https://gerrit.wikimedia.org/r/510230

You can now use the config variable $wgVisualEditorEnableNewMobileContext = true; to enable the new version of mobile contexts.

Some representative examples:

Old contextsNew contexts
Link
Image

I'm assuming further work is happening somewhere else (I'm a bit lost in this forest of tasks).

(QA is happening on T221311)

ppelberg closed this task as Resolved.Jun 20 2019, 9:11 PM
ppelberg claimed this task.